KDesktopFile Class Reference

`#include <kdesktopfile.h>`

Inheritance diagram for KDesktopFile:

## Public Member Functions

| KDesktopFile (const QString &fileName, bool readOnly=false, const char *resType="apps")
virtual | ~KDesktopFile ()
QString | readType () const
QString | readIcon () const
QString | readName () const
QString | readComment () const
QString | readGenericName () const
QString | readPath () const
QString | readDevice () const
QString | readURL () const
QStringList | readActions () const
void | setActionGroup (const QString &group)
bool | hasActionGroup (const QString &group) const
bool | hasLinkType () const
bool | hasApplicationType () const
bool | hasMimeTypeType () const
bool | hasDeviceType () const
bool | tryExec () const
QString | fileName () const
QString | resource () const
QString | readDocPath () const
QStringList | sortOrder () const
KDesktopFile * | copyTo (const QString &file) const
KDE_DEPRECATED QString | filename () const
Public Member Functions inherited from KConfig
| KConfig (const QString &fileName=QString::null, bool bReadOnly=false, bool bUseKDEGlobals=true, const char *resType="config")
| KConfig (KConfigBackEnd *backEnd, bool bReadOnly=false)
virtual | ~KConfig ()
virtual void | rollback (bool bDeep=true)
virtual QStringList | groupList () const
virtual QMap< QString, QString > | entryMap (const QString &pGroup) const
virtual void | reparseConfiguration ()
void | setFileWriteMode (int mode)
void | setForceGlobal (bool force)
bool | forceGlobal () const
void | checkUpdate (const QString &id, const QString &updateFile)
KConfig * | copyTo (const QString &file, KConfig *config=0) const
KLockFile::Ptr | lockFile (bool bGlobal=false)
Public Member Functions inherited from KConfigBase
| KConfigBase ()
virtual | ~KConfigBase ()
void | setGroup (const QString &group)
void | setDesktopGroup ()
QString | group () const
bool | hasGroup (const QString &group) const
QString | locale () const
QString | readEntry (const QString &pKey, const QString &aDefault=QString::null) const
QString | readEntry (const char *pKey, const QString &aDefault=QString::null) const
QVariant | readPropertyEntry (const QString &pKey, QVariant::Type) const
QVariant | readPropertyEntry (const char *pKey, QVariant::Type) const
QVariant | readPropertyEntry (const QString &pKey, const QVariant &aDefault) const
QVariant | readPropertyEntry (const char *pKey, const QVariant &aDefault) const
int | readListEntry (const QString &pKey, QStrList &list, char sep= ',') const
int | readListEntry (const char *pKey, QStrList &list, char sep= ',') const
QStringList | readListEntry (const QString &pKey, char sep= ',') const
QStringList | readListEntry (const char *pKey, char sep= ',') const
QStringList | readListEntry (const char *pKey, const QStringList &aDefault, char sep= ',') const
QValueList< int > | readIntListEntry (const QString &pKey) const
QValueList< int > | readIntListEntry (const char *pKey) const
QString | readPathEntry (const QString &pKey, const QString &aDefault=QString::null) const
QString | readPathEntry (const char *pKey, const QString &aDefault=QString::null) const
QStringList | readPathListEntry (const QString &pKey, char sep= ',') const
QStringList | readPathListEntry (const char *pKey, char sep= ',') const
int | readNumEntry (const QString &pKey, int nDefault=0) const
int | readNumEntry (const char *pKey, int nDefault=0) const
unsigned int | readUnsignedNumEntry (const QString &pKey, unsigned int nDefault=0) const
unsigned int | readUnsignedNumEntry (const char *pKey, unsigned int nDefault=0) const
long | readLongNumEntry (const QString &pKey, long nDefault=0) const
long | readLongNumEntry (const char *pKey, long nDefault=0) const
unsigned long | readUnsignedLongNumEntry (const QString &pKey, unsigned long nDefault=0) const
unsigned long | readUnsignedLongNumEntry (const char *pKey, unsigned long nDefault=0) const
Q_INT64 | readNum64Entry (const QString &pKey, Q_INT64 nDefault=0) const
Q_INT64 | readNum64Entry (const char *pKey, Q_INT64 nDefault=0) const
Q_UINT64 | readUnsignedNum64Entry (const QString &pKey, Q_UINT64 nDefault=0) const
Q_UINT64 | readUnsignedNum64Entry (const char *pKey, Q_UINT64 nDefault=0) const
double | readDoubleNumEntry (const QString &pKey, double nDefault=0.0) const
double | readDoubleNumEntry (const char *pKey, double nDefault=0.0) const
QFont | readFontEntry (const QString &pKey, const QFont *pDefault=0L) const
QFont | readFontEntry (const char *pKey, const QFont *pDefault=0L) const
bool | readBoolEntry (const QString &pKey, bool bDefault=false) const
bool | readBoolEntry (const char *pKey, bool bDefault=false) const
QRect | readRectEntry (const QString &pKey, const QRect *pDefault=0L) const
QRect | readRectEntry (const char *pKey, const QRect *pDefault=0L) const
QPoint | readPointEntry (const QString &pKey, const QPoint *pDefault=0L) const
QPoint | readPointEntry (const char *pKey, const QPoint *pDefault=0L) const
QSize | readSizeEntry (const QString &pKey, const QSize *pDefault=0L) const
QSize | readSizeEntry (const char *pKey, const QSize *pDefault=0L) const
QColor | readColorEntry (const QString &pKey, const QColor *pDefault=0L) const
QColor | readColorEntry (const char *pKey, const QColor *pDefault=0L) const
QDateTime | readDateTimeEntry (const QString &pKey, const QDateTime *pDefault=0L) const
QDateTime | readDateTimeEntry (const char *pKey, const QDateTime *pDefault=0L) const
QString | readEntryUntranslated (const QString &pKey, const QString &aDefault=QString::null) const
QString | readEntryUntranslated (const char *pKey, const QString &aDefault=QString::null) const
void | writeEntry (const QString &pKey, const QString &pValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QString &pValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const QVariant &rValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QVariant &rValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const QStrList &rValue, char sep= ',', bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QStrList &rValue, char sep= ',', bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const QStringList &rValue, char sep= ',', bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QStringList &rValue, char sep= ',', bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const QValueList< int > &rValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QValueList< int > &rValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const char *pValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const char *pValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, int nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, int nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, unsigned int nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, unsigned int nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, long nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, long nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, unsigned long nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, unsigned long nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, Q_INT64 nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, Q_INT64 nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, Q_UINT64 nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, Q_UINT64 nValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, double nValue, bool bPersistent=true, bool bGlobal=false, char format= 'g', int precision=6, bool bNLS=false)
void | writeEntry (const char *pKey, double nValue, bool bPersistent=true, bool bGlobal=false, char format= 'g', int precision=6, bool bNLS=false)
void | writeEntry (const QString &pKey, bool bValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, bool bValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const QFont &rFont, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QFont &rFont, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const QColor &rColor, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QColor &rColor, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const QDateTime &rDateTime, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QDateTime &rDateTime, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const QRect &rValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QRect &rValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const QPoint &rValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QPoint &rValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const QString &pKey, const QSize &rValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writeEntry (const char *pKey, const QSize &rValue, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writePathEntry (const QString &pKey, const QString &path, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writePathEntry (const char *pKey, const QString &path, bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writePathEntry (const QString &pKey, const QStringList &rValue, char sep= ',', bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | writePathEntry (const char *pKey, const QStringList &rValue, char sep= ',', bool bPersistent=true, bool bGlobal=false, bool bNLS=false)
void | deleteEntry (const QString &pKey, bool bNLS=false, bool bGlobal=false)
void | deleteEntry (const char *pKey, bool bNLS=false, bool bGlobal=false)
bool | deleteGroup (const QString &group, bool bDeep=true, bool bGlobal=false)
void | setDollarExpansion (bool _bExpand=true)
bool | isDollarExpansion () const
virtual void | sync ()
bool | isDirty () const
virtual void | setReadOnly (bool _ro)
bool | isReadOnly () const
bool | hasKey (const QString &key) const
bool | isImmutable () const
bool | groupIsImmutable (const QString &group) const
bool | entryIsImmutable (const QString &key) const
ConfigState | getConfigState () const
bool | checkConfigFilesWritable (bool warnUser)
void | setReadDefaults (bool b)
bool | readDefaults () const
void | revertToDefault (const QString &key)
bool | hasDefault (const QString &key) const
void | setGroup (const QCString &pGroup)
void | setGroup (const char *pGroup)
bool | hasGroup (const QCString &_pGroup) const
bool | hasGroup (const char *_pGroup) const
bool | hasKey (const char *pKey) const

## Static Public Member Functions

static bool | isDesktopFile (const QString &path)
static bool | isAuthorizedDesktopFile (const QString &path)
static QString | locateLocal (const QString &path)

## Protected Member Functions

virtual void | virtual_hook (int id, void *data)
Protected Member Functions inherited from KConfig
virtual bool | internalHasGroup (const QCString &group) const
virtual KEntryMap | internalEntryMap (const QString &pGroup) const
virtual KEntryMap | internalEntryMap () const
virtual void | putData (const KEntryKey &_key, const KEntry &_data, bool _checkGroup=true)
virtual KEntry | lookupData (const KEntryKey &_key) const
Protected Member Functions inherited from KConfigBase
void | setLocale ()
virtual void | setDirty (bool _bDirty=true)
virtual void | parseConfigFiles ()
QCString | readEntryUtf8 (const char *pKey) const

## Additional Inherited Members

Public Types inherited from KConfigBase
enum | ConfigState { NoAccess, ReadOnly, ReadWrite }
Protected Attributes inherited from KConfig
KEntryMap | aEntryMap
Protected Attributes inherited from KConfigBase
KConfigBackEnd * | backEnd
QCString | mGroup
QCString | aLocaleString
bool | bDirty
bool | bLocaleInitialized
bool | bReadOnly
bool | bExpand

## Detailed Description

KDE Desktop File Management.

Author
  Pietro Iglio iglio.nosp@m.@kde.nosp@m..org

See also
  KConfigBase KConfig KDE Desktop File Management class

Definition at line 34 of file kdesktopfile.h.

## Constructor & Destructor Documentation

KDesktopFile::KDesktopFile | ( | const QString & | fileName,
|  | bool | readOnly = `false`,
|  | const char * | resType = `"apps"`
| ) |  |

Constructs a KDesktopFile object and make it either read-write or read-only.

Parameters

  fileName | The name or path of the desktop file. If it is not absolute, it will be located using the resource type `resType`.
  readOnly | Whether the object should be read-only.
  resType | Allows you to change what sort of resource to search for if `fileName` is not absolute. For instance, you might want to specify "config".

Definition at line 41 of file kdesktopfile.cpp.

KDesktopFile::~KDesktopFile | ( |  | ) |

virtual

Destructs the KDesktopFile object.

Writes back any dirty configuration entries.

Definition at line 54 of file kdesktopfile.cpp.

## Member Function Documentation

KDesktopFile * KDesktopFile::copyTo | ( | const QString & | file | ) | const

Copies all entries from this config object to a new KDesktopFile object that will save itself to `file`.

Actual saving to `file` happens when the returned object is destructed or when sync() is called upon it.

Parameters

  file | the new KDesktopFile object it will save itself to.

Since
  3.2

Definition at line 338 of file kdesktopfile.cpp.

QString KDesktopFile::fileName | ( |  | ) | const

Returns the file name.

Returns
  The filename as passed to the constructor.
  the filename as passed to the constructor.

Definition at line 311 of file kdesktopfile.cpp.

KDE_DEPRECATED QString KDesktopFile::filename | ( |  | ) | const

inline

Deprecated:
  Use fileName() instead.

Definition at line 235 of file kdesktopfile.h.

bool KDesktopFile::hasActionGroup | ( | const QString & | group | ) | const

Returns true if the action group exists, false otherwise.

Parameters

  group | the action group to test

Returns
  true if the action group exists

Definition at line 224 of file kdesktopfile.cpp.

bool KDesktopFile::hasApplicationType | ( |  | ) | const

Checks whether there is an entry "Type=Application".

Returns
  true if there is a "Type=Application" entry

Definition at line 234 of file kdesktopfile.cpp.

bool KDesktopFile::hasDeviceType | ( |  | ) | const

Checks whether there is an entry "Type=FSDev".

Returns
  true if there is a "Type=FSDev" entry

Definition at line 244 of file kdesktopfile.cpp.

bool KDesktopFile::hasLinkType | ( |  | ) | const

Checks whether there is a "Type=Link" entry.

The link points to the "URL=" entry.

Returns
  true if there is a "Type=Link" entry

Definition at line 229 of file kdesktopfile.cpp.

bool KDesktopFile::hasMimeTypeType | ( |  | ) | const

Checks whether there is an entry "Type=MimeType".

Returns
  true if there is a "Type=MimeType" entry

Definition at line 239 of file kdesktopfile.cpp.

bool KDesktopFile::isAuthorizedDesktopFile | ( | const QString & | path | ) |

static

Checks whether the user is authorized to run this desktop file.

By default users are authorized to run all desktop files but the KIOSK framework can be used to activate certain restrictions. See README.kiosk for more information.

Parameters

  path | the file to check

Returns
  true if the user is authorized to run the file

Since
  3.1

Definition at line 123 of file kdesktopfile.cpp.

bool KDesktopFile::isDesktopFile | ( | const QString & | path | ) |

static

Checks whether this is really a desktop file.

The check is performed looking at the file extension (the file is not opened). Currently, valid extensions are ".kdelnk" and ".desktop".

Parameters

  path | the path of the file to check

Returns
  true if the file appears to be a desktop file.

Definition at line 111 of file kdesktopfile.cpp.

QString KDesktopFile::locateLocal | ( | const QString & | path | ) |

static

Returns the location where changes for the .desktop file `path` should be written to.

Since
  3.2

Definition at line 59 of file kdesktopfile.cpp.

QStringList KDesktopFile::readActions | ( |  | ) | const

Returns a list of the "Actions=" entries.

Returns
  the list of actions

Definition at line 214 of file kdesktopfile.cpp.

QString KDesktopFile::readComment | ( |  | ) | const

Returns the value of the "Comment=" entry.

Returns
  the comment or QString::null if not specified

Definition at line 163 of file kdesktopfile.cpp.

QString KDesktopFile::readDevice | ( |  | ) | const

Returns the value of the "Dev=" entry.

Returns
  the device or QString::null if not specified

Definition at line 178 of file kdesktopfile.cpp.

QString KDesktopFile::readDocPath | ( |  | ) | const

Returns the value of the "X-DocPath=" Or "DocPath=" entry.

X-DocPath should be used and DocPath is depreciated and will one day be not supported.

Returns
  The value of the "X-DocPath=" Or "DocPath=" entry.

Since
  3.1

Definition at line 328 of file kdesktopfile.cpp.

QString KDesktopFile::readGenericName | ( |  | ) | const

Returns the value of the "GenericName=" entry.

Returns
  the generic name or QString::null if not specified

Definition at line 168 of file kdesktopfile.cpp.

QString KDesktopFile::readIcon | ( |  | ) | const

Returns the value of the "Icon=" entry.

Returns
  the icon or QString::null if not specified

Definition at line 153 of file kdesktopfile.cpp.

QString KDesktopFile::readName | ( |  | ) | const

Returns the value of the "Name=" entry.

Returns
  the name or QString::null if not specified

Definition at line 158 of file kdesktopfile.cpp.

QString KDesktopFile::readPath | ( |  | ) | const

Returns the value of the "Path=" entry.

Returns
  the path or QString::null if not specified

Definition at line 173 of file kdesktopfile.cpp.

QString KDesktopFile::readType | ( |  | ) | const

Returns the value of the "Type=" entry.

Returns
  the type or QString::null if not specified

Definition at line 148 of file kdesktopfile.cpp.

QString KDesktopFile::readURL | ( |  | ) | const

Returns the value of the "URL=" entry.

Returns
  the URL or QString::null if not specified

Definition at line 183 of file kdesktopfile.cpp.

QString KDesktopFile::resource | ( |  | ) | const

Returns the resource.

Returns
  The resource type as passed to the constructor.
  the resource type as passed to the constructor.

Definition at line 317 of file kdesktopfile.cpp.

void KDesktopFile::setActionGroup | ( | const QString & | group | ) |

Sets the desktop action group.

Parameters

  group | the new action group

Definition at line 219 of file kdesktopfile.cpp.

QStringList KDesktopFile::sortOrder | ( |  | ) | const

Returns the entry of the "SortOrder=" entry.

Returns
  the value of the "SortOrder=" entry.

Definition at line 320 of file kdesktopfile.cpp.

bool KDesktopFile::tryExec | ( |  | ) | const

Checks whether the TryExec field contains a binary which is found on the local system.

Returns
  true if TryExec contains an existing binary

Definition at line 250 of file kdesktopfile.cpp.

The documentation for this class was generated from the following files:

- kdesktopfile.h
- kdesktopfile.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys